<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2 Final//EN">

<!--Converted with LaTeX2HTML 2002-2-1 (1.70)
original version by:  Nikos Drakos, CBLU, University of Leeds
* revised and updated by:  Marcus Hennecke, Ross Moore, Herb Swan
* with significant contributions from:
  Jens Lippmann, Marek Rouchal, Martin Wilck and others -->
<HTML>
<HEAD>
<TITLE>readinput</TITLE>
<META NAME="description" CONTENT="readinput">
<META NAME="keywords" CONTENT="ccx">
<META NAME="resource-type" CONTENT="document">
<META NAME="distribution" CONTENT="global">

<META NAME="Generator" CONTENT="LaTeX2HTML v2002-2-1">
<META HTTP-EQUIV="Content-Style-Type" CONTENT="text/css">

<LINK REL="STYLESHEET" HREF="ccx.css">

<LINK REL="next" HREF="node335.html">
<LINK REL="previous" HREF="node333.html">
<LINK REL="up" HREF="node332.html">
<LINK REL="next" HREF="node335.html">
</HEAD>

<BODY >
<!--Navigation Panel-->
<A NAME="tex2html5246"
  HREF="node335.html">
<IMG WIDTH="37" HEIGHT="24" ALIGN="BOTTOM" BORDER="0" ALT="next"
 SRC="file:/usr/share/latex2html/icons/next.png"></A> 
<A NAME="tex2html5242"
  HREF="node332.html">
<IMG WIDTH="26" HEIGHT="24" ALIGN="BOTTOM" BORDER="0" ALT="up"
 SRC="file:/usr/share/latex2html/icons/up.png"></A> 
<A NAME="tex2html5236"
  HREF="node333.html">
<IMG WIDTH="63" HEIGHT="24" ALIGN="BOTTOM" BORDER="0" ALT="previous"
 SRC="file:/usr/share/latex2html/icons/prev.png"></A> 
<A NAME="tex2html5244"
  HREF="node1.html">
<IMG WIDTH="65" HEIGHT="24" ALIGN="BOTTOM" BORDER="0" ALT="contents"
 SRC="file:/usr/share/latex2html/icons/contents.png"></A>  
<BR>
<B> Next:</B> <A NAME="tex2html5247"
  HREF="node335.html">allocate</A>
<B> Up:</B> <A NAME="tex2html5243"
  HREF="node332.html">Allocation of the fields</A>
<B> Previous:</B> <A NAME="tex2html5237"
  HREF="node333.html">openfile</A>
 &nbsp; <B>  <A NAME="tex2html5245"
  HREF="node1.html">Contents</A></B> 
<BR>
<BR>
<!--End of Navigation Panel-->

<H3><A NAME="SECTION000101200000000000000">
readinput</A>
</H3>

<P>
This subroutine reads the input and stores it in field inpc. Before storing,
the following actions are performed:

<P>

<UL>
<LI>the blanks are deleted
</LI>
<LI>all characters are changed to uppercase except file names
</LI>
<LI>the comment lines are not stored
</LI>
<LI>the include statements are expanded
</LI>
</UL>

<P>
Furthermore, the number of sets are counted and stored in nset_, the number of
lines in inpc are stored in nline. The variable nset_ is used for subsequent
allocation purposes. Finally, the order in which inpc is to be read is stored
in the fields ipoinp and inp. Indeed, some keyword cards cannot be interpreted
before others were read, e.g. a material reference in a *SOLID SECTION card
cannot be interpreted before the material definition in the *MATERIAl card was
read. The order in which keyword cards must be read is defined in field
nameref in subroutine keystart.f. Right now, it reads:

<P>

<OL>
<LI>*RESTART,READ
</LI>
<LI>*NODE
</LI>
<LI>*ELEMENT
</LI>
<LI>*NSET
</LI>
<LI>*ELSET
</LI>
<LI>*TRANSFORM
</LI>
<LI>*MATERIAL
</LI>
<LI>*ORIENTATION
</LI>
<LI>*SURFACE
</LI>
<LI>*TIE
</LI>
<LI>*SURFACE INTERACTION
</LI>
<LI>*INITIAL CONDITIONS
</LI>
<LI>*AMPLITUDE
</LI>
<LI>*CONTACTPAIR
</LI>
<LI>everything else
</LI>
</OL>

<P>
This means that *RESTART,READ has to be read before all other cards, then
comes *NODE etc. The way inpc is to be read is stored in the fields ipoinp,
inp and ipoinpc. The two-dimensional field ipoinp consists of 2 columns and nentries rows,
where nentries is the number of keyword cards listed in the list above,
i.e. right now nentries=15. The first column of row i in field ipoinp contains
a row number of field inp, for instance j1. Then, the first column
of row j1 in field inp contains the line number where reading for keyword i
should start, the second column contains the line number where reading should
end and the third column contains the line number in field inp where  the
reading information
for keyword i continues, else it is zero. If it is zero the corresponding row
number in inp is stored in the second column of row i in field ipoinp. 
Lines are stored consecutively in field inpc (without blanks and without
comment lines). Line l1 starts at ipoinpc(l1-1)+1 (first character) and ends at
ipoinpc(l1) (last character). Notice that ipoinpc(0)=0. This
structure uniquely specifies in what order field inpc must be read. This is
also illustrated in Figure <A HREF="#input">140</A>

<P>

<DIV ALIGN="CENTER"><A NAME="input"></A><A NAME="11025"></A>
<TABLE>
<CAPTION ALIGN="BOTTOM"><STRONG>Figure 140:</STRONG>
Reading the lines for keyword entry i</CAPTION>
<TR><TD><IMG
 WIDTH="448" HEIGHT="280" BORDER="0"
 SRC="img1648.png"
 ALT="\begin{figure}\epsfig{file=input.eps,width=10cm}\end{figure}"></TD></TR>
</TABLE>
</DIV>

<P>
If you want to add keywords in the above list you have to 

<P>

<UL>
<LI>update nentries in
the parameter statement in the FORTRAN subroutines allocation.f, calinput.f, keystart.f,
getnewline.f and writeinput.f 
</LI>
<LI>update the initialization of nentries in the
C-routines ccx_2.11.c and readinput.c. 
</LI>
<LI>update the data statement for
the field nameref in the FORTRAN subroutines keystart.f and writeinput.f 
</LI>
<LI>update
the data statement for the field namelen in the FORTRAN subroutine
keystart.f. It contains the number of characters in each keyword.
</LI>
<LI>look for the block running

<P>
<PRE>
      else if(strcmp1(&amp;buff[0],"*AMPLITUDE")==0){
        FORTRAN(keystart,(&amp;ifreeinp,ipoinp,inp,"AMPLITUDE",
                          nline,&amp;ikey));
			  }
</PRE>

<P>
in file readinput.c, copy the block and replace AMPLITUDE by the new keyword.
</LI>
</UL>

<P>
<HR>
<!--Navigation Panel-->
<A NAME="tex2html5246"
  HREF="node335.html">
<IMG WIDTH="37" HEIGHT="24" ALIGN="BOTTOM" BORDER="0" ALT="next"
 SRC="file:/usr/share/latex2html/icons/next.png"></A> 
<A NAME="tex2html5242"
  HREF="node332.html">
<IMG WIDTH="26" HEIGHT="24" ALIGN="BOTTOM" BORDER="0" ALT="up"
 SRC="file:/usr/share/latex2html/icons/up.png"></A> 
<A NAME="tex2html5236"
  HREF="node333.html">
<IMG WIDTH="63" HEIGHT="24" ALIGN="BOTTOM" BORDER="0" ALT="previous"
 SRC="file:/usr/share/latex2html/icons/prev.png"></A> 
<A NAME="tex2html5244"
  HREF="node1.html">
<IMG WIDTH="65" HEIGHT="24" ALIGN="BOTTOM" BORDER="0" ALT="contents"
 SRC="file:/usr/share/latex2html/icons/contents.png"></A>  
<BR>
<B> Next:</B> <A NAME="tex2html5247"
  HREF="node335.html">allocate</A>
<B> Up:</B> <A NAME="tex2html5243"
  HREF="node332.html">Allocation of the fields</A>
<B> Previous:</B> <A NAME="tex2html5237"
  HREF="node333.html">openfile</A>
 &nbsp; <B>  <A NAME="tex2html5245"
  HREF="node1.html">Contents</A></B> 
<!--End of Navigation Panel-->
<ADDRESS>
guido dhondt
2016-07-31
</ADDRESS>
</BODY>
</HTML>
